on startMovie
  global gTracker1, QTSpriteNum, gNavHiliteSprite, gCharButWide, gCharButHigh, gCharButDistLeft, gIrisButDistTop, gMspButDistTop, gPlaButDistTop, gSkeButWide, gSkeButHigh, gSkeButDistLeft, gSkeButDistTop, gPianButDistLeft, gPianButDistTop, gClrbook, gLooper, gQuitButWide, gQuitButHigh, gQuitButDistLeft, gQuitButDistTop, gRememberMe, gLeftCharBank, gGoQuit, ChalkButtonWidth, ChalkButtonHeight, eraserButtonWidth, eraserButtonHeight, leftChalkButtonLocH, leftChalkButtonLocV, rightChalkButtonLocH, rightChalkButtonLocV, eraserButtonLocH, eraserButtonLocV, leftChalkHighlightLocH, leftChalkHighlightLocV, rightChalkHighlightLocH, rightChalkHighlightLocV, eraserHighlightLocH, eraserHighlightLocV, gLastMovieName, gMovieNum, gWhichFrame, gQTduration, gQTMovieNow, gTabButtonW, gTabButtonH, gLogLocH, gLogLocV, gCreditLocH, gCreditLocV, gTipLocH, gTipLocV, gPreLocH, gPreLocV, gLogRevH, gLogRevV, gCreditRevH, gCreditRevV, gTipRevH, gTipRevV, gHotTab, goTyping, gPlaceHolder, gAposChannel
  if the machineType = 256 then
    openXLib("movutils.dll")
  else
    openXLib("StageToCast.XObj")
  end if
  set the exitLock to 1
  when keyDown then nothing --stop the keyDown script that jumps to page 0 or 1
  ResetSoundLevel()
  set gTracker1 to pointerFactory(mnew, 3)
  set the immediate of sprite 18 to 1
  set QTSpriteNum to 19
  set gNavHiliteSprite to 23
  set the immediate of sprite gNavHiliteSprite to 1
  set gGoQuit to 18
  set the immediate of sprite gGoQuit to 1
  set gLeftCharBank to 20
  set the immediate of sprite gLeftCharBank to 1
  charButtonInit()
  navButtonInit()
  set gMovieNum to 0
  set gWhichFrame to "Intro"
  set gTabButtonW to 20
  set gTabButtonH to 50
  set gLogLocH to 495
  set gLogLocV to 114
  set gCreditLocH to 498
  set gCreditLocV to 167
  set gTipLocH to 503
  set gTipLocV to 222
  set gPreLocH to 506
  set gPreLocV to 277
  set gLogRevH to 127
  set gLogRevV to 115
  set gCreditRevH to 129
  set gCreditRevV to 169
  set gTipRevH to 136
  set gTipRevV to 221
  set gHotTab to 15
  set the immediate of sprite gHotTab to 1
  set gAposChannel to 14
  puppetSprite(gAposChannel, 1)
  set the locH of sprite gAposChannel to -100
  set the locV of sprite gAposChannel to -100
  NameCaptInit()
  puppetSound(0)
  updateStage()
end

on stopMovie
  global gTracker1, gNavHiliteSprite, nameObj
  gTracker1(mdispose)
  set the immediate of sprite gNavHiliteSprite to 0
  when mouseUp then nothing  
  pStopTyping()
  if objectp(nameObj) then
    nameObj(mdispose)
  end if
  if the machineType = 256 then
    closeXLib("movutils.dll")
  else
    closeXLib("StageToCast.XObj")
  end if
end

on goGameQuitter
  pStopTyping()
end

on LogButton
  global gTabButtonW, gTabButtonH, QTSpriteNum, gLogLocH, gLogLocV, gCreditLocH, gCreditLocV, gTipLocH, gTipLocV, gPreLocH, gPreLocV
  pStopTyping()
  set mh to the mouseH
  set mv to the mouseV
  when timeOut then nothing
  set the visible of sprite QTSpriteNum to 0
  if (mh > gCreditLocH) and (mh < (gCreditLocH + gTabButtonW)) and ((mv > gCreditLocV) and (mv < (gCreditLocV + gTabButtonH))) then
    puppetSound("TurnP.aif")
    updateStage()
    HideTheName()
    go("Credit")
  else
    if (mh > gTipLocH) and (mh < (gTipLocH + gTabButtonW)) and ((mv > gTipLocV) and (mv < (gTipLocV + gTabButtonH))) then
      puppetSound("TurnP.aif")
      updateStage()
      HideTheName()
      go("Tips")
    else
      if (mh > gPreLocH) and (mh < (gPreLocH + gTabButtonW)) and ((mv > gPreLocV) and (mv < (gPreLocV + gTabButtonH))) then
        puppetSound("TurnP.aif")
        updateStage()
        HideTheName()
        go("Previews")
      end if
    end if
  end if
end

on LogFlipOne
  global gTabButtonW, gTabButtonH, gLogRevH, gLogRevV, gCreditLocH, gCreditLocV, gTipLocH, gTipLocV, gPreLocH, gPreLocV
  set mh to the mouseH
  set mv to the mouseV
  if (mh > gLogRevH) and (mh < (gLogRevH + gTabButtonW)) and ((mv > gLogRevV) and (mv < (gLogRevV + gTabButtonH))) then
    puppetSound("TurnP.aif")
    updateStage()
    ShowTheName()
    go("NamePage")
  else
    if (mh > gCreditLocH) and (mh < (gCreditLocH + gTabButtonW)) and ((mv > gCreditLocV) and (mv < (gCreditLocV + gTabButtonH))) then
      puppetSound("TurnP.aif")
      updateStage()
      go("Credit")
    else
      if (mh > gTipLocH) and (mh < (gTipLocH + gTabButtonW)) and ((mv > gTipLocV) and (mv < (gTipLocV + gTabButtonH))) then
        puppetSound("TurnP.aif")
        updateStage()
        go("Tips")
      else
        if (mh > gPreLocH) and (mh < (gPreLocH + gTabButtonW)) and ((mv > gPreLocV) and (mv < (gPreLocV + gTabButtonH))) then
          puppetSound("TurnP.aif")
          updateStage()
          go("Previews")
        end if
      end if
    end if
  end if
end

on LogFlipTwo
  global gTabButtonW, gTabButtonH, gLogRevH, gLogRevV, gCreditRevH, gCreditRevV, gTipLocH, gTipLocV, gPreLocH, gPreLocV
  set mh to the mouseH
  set mv to the mouseV
  if (mh > gLogRevH) and (mh < (gLogRevH + gTabButtonW)) and ((mv > gLogRevV) and (mv < (gLogRevV + gTabButtonH))) then
    puppetSound("TurnP.aif")
    updateStage()
    ShowTheName()
    go("NamePage")
  else
    if (mh > gCreditRevH) and (mh < (gCreditRevH + gTabButtonW)) and ((mv > gCreditRevV) and (mv < (gCreditRevV + gTabButtonH))) then
      puppetSound("TurnP.aif")
      updateStage()
      go("Credit")
    else
      if (mh > gTipLocH) and (mh < (gTipLocH + gTabButtonW)) and ((mv > gTipLocV) and (mv < (gTipLocV + gTabButtonH))) then
        puppetSound("TurnP.aif")
        updateStage()
        go("Tips")
      else
        if (mh > gPreLocH) and (mh < (gPreLocH + gTabButtonW)) and ((mv > gPreLocV) and (mv < (gPreLocV + gTabButtonH))) then
          puppetSound("TurnP.aif")
          updateStage()
          go("Previews")
        end if
      end if
    end if
  end if
end

on LogFlipThree
  global gTabButtonW, gTabButtonH, gLogRevH, gLogRevV, gCreditRevH, gCreditRevV, gTipRevH, gTipRevV, gPreLocH, gPreLocV
  set mh to the mouseH
  set mv to the mouseV
  if (mh > gLogRevH) and (mh < (gLogRevH + gTabButtonW)) and ((mv > gLogRevV) and (mv < (gLogRevV + gTabButtonH))) then
    puppetSound("TurnP.aif")
    updateStage()
    ShowTheName()
    go("NamePage")
  else
    if (mh > gCreditRevH) and (mh < (gCreditRevH + gTabButtonW)) and ((mv > gCreditRevV) and (mv < (gCreditRevV + gTabButtonH))) then
      puppetSound("TurnP.aif")
      updateStage()
      go("Credit")
    else
      if (mh > gTipRevH) and (mh < (gTipRevH + gTabButtonW)) and ((mv > gTipRevV) and (mv < (gTipRevV + gTabButtonH))) then
        puppetSound("TurnP.aif")
        updateStage()
        go("Tips")
      else
        if (mh > gPreLocH) and (mh < (gPreLocH + gTabButtonW)) and ((mv > gPreLocV) and (mv < (gPreLocV + gTabButtonH))) then
          puppetSound("TurnP.aif")
          updateStage()
          go("Previews")
        end if
      end if
    end if
  end if
end

on pInitTyping
  global goTyping
  if objectp(goTyping) then
    goTyping(mdispose)
  end if
  set goTyping to fTyping(mnew)
  when keyDown then goTyping(mHitKey) 
end

on pStopTyping
  global goTyping
  repeat with x = 4 to 14
    if the puppet of sprite x = 1 then
      set the visible of sprite x to 0
      puppetSprite(x, 0)
      set the visible of sprite x to 1
    end if
  end repeat
  if objectp(goTyping) then
    goTyping(mSetPuppets, 0)
    goTyping(mdispose)
  end if
  when keyDown then nothing
end

on NameSwapInit
  global gnameCastNum, gLetterHeight, gMidPage, theNameSprite, gNewStartPoint, gPasteStart, gNameLeft, gNameRight, gNameTop, gNameBot, gNameWide, gNameTall, goTyping
  set theNameSprite to 22
  puppetSprite(theNameSprite, 1)
  set the stretch of sprite theNameSprite to 0
  set the castNum of sprite theNameSprite to gnameCastNum
  set the locV of sprite theNameSprite to gNameTop + (gNameTall / 2)
  set the locH of sprite theNameSprite to gNameLeft + (gNameWide / 2)
  if objectp(goTyping) then
    set the visible of sprite theNameSprite to 0
  else
    set the visible of sprite theNameSprite to 1
    updateStage()
  end if
end

on NameCaptInit
  global gNameLeft, gNameRight, gNameTop, gNameBot, gNameWide, gNameTall
  set gNameLeft to 316
  set gNameRight to 494
  set gNameTop to 114
  set gNameBot to 186
  set gNameWide to 178
  set gNameTall to 72
end

on ShowTheName
  global theNameSprite
  set the visible of sprite theNameSprite to 1
end

on HideTheName
  global theNameSprite
  set the visible of sprite theNameSprite to 0
end

on Page0StopAllSound
  global QTSpriteNum
  if the visible of sprite QTSpriteNum = 1 then
    set the movieRate of sprite QTSpriteNum to 0
    set the movieTime of sprite QTSpriteNum to 0
    set the visible of sprite QTSpriteNum to 0
  end if
  puppetSound(0)
  updateStage()
end

factory fTyping
method mnew
  instance mouseDown, ichFirstLetter, iMaxLetters, iNameString, iLetterNumber, iLowerLetters, iLetters, iLetterHit, iNextH
  global gPlaceHolder
  set iMaxLetters to 9
  set ichFirstLetter to 4
  set iLetterNumber to 1
  set iNameString to "         "
  set iLowerLetters to "abcdefghijklmnopqrstuvwxyz"
  set iLetters to "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-'. "
  set iNextH to the left of sprite ichFirstLetter
  me(mSetPuppets, 1)

method mSetPuppets trueOrFalse
  repeat with i = ichFirstLetter to ichFirstLetter + iMaxLetters - 1
    puppetSprite(i, trueOrFalse)
    set the stretch of sprite i to 0
  end repeat

method mHitKey
  global gLastKey
  if the commandDown or the controlDown or the optionDown then
    exit
  end if
  set iLetterHit to the key
  if iLetterHit = BACKSPACE then
    set gLastKey to " "
    if iLetterNumber = 1 then
      beep()
    else
      set iLetterNumber to iLetterNumber - 1
      set gLastKey to char iLetterNumber - 1 of iNameString
      put " " into char iLetterNumber of iNameString
      me(mDrawAll)
    end if
  else
    if iLetterNumber > iMaxLetters then
      beep()
      exit
    end if
    set theLetterOffset to 0
    set theLetterOffset to offset(iLetterHit, iLowerLetters)
    if theLetterOffset <> 0 then
      set iLetterHit to chars(iLetters, theLetterOffset, theLetterOffset)
    else
      set theLetterOffset to offset(iLetterHit, iLetters)
    end if
    if theLetterOffset = 0 then
      beep()
      exit
    end if
    set gLastKey to iLetterHit
    put iLetterHit into char iLetterNumber of iNameString
    me(mDraw)
    set iLetterNumber to iLetterNumber + 1
    dontPassEvent()
  end if

method mDraw
  global gPlaceHolder
  set theChannel to ichFirstLetter + iLetterNumber - 1
  set theLetter to char iLetterNumber of iNameString
  set theLetterOffset to offset(theLetter, iLetters)
  set theNewCast to the number of cast "FirstLetter" + theLetterOffset - 1
  set the castNum of sprite theChannel to theNewCast
  set the locH of sprite theChannel to iNextH
  updateStage()
  set iNextH to iNextH + (the right of sprite theChannel - the left of sprite theChannel)
  set gPlaceHolder to iNextH

method mDrawAll
  global gFullName, gPlaceHolder
  set iNextH to the left of sprite ichFirstLetter
  repeat with i = 1 to iMaxLetters
    set theChannel to ichFirstLetter + i - 1
    set theLetter to char i of iNameString
    set theLetterOffset to offset(theLetter, iLetters)
    set theNewCast to the number of cast "FirstLetter" + theLetterOffset - 1
    set the castNum of sprite theChannel to theNewCast
    set the locH of sprite theChannel to iNextH
    if i < iLetterNumber then
      set iNextH to iNextH + (the right of sprite theChannel - the left of sprite theChannel)
    end if
  end repeat
  updateStage()
  set gPlaceHolder to iNextH
  set gFullName to iNameString

method mPronounceLetter
  set castNameToPlay to iLetterHit
  if castNameToPlay = "'" then
    set castNameToPlay to "Apostrophe"
  else
    if castNameToPlay = " " then
      set castNameToPlay to "Space"
    else
      if castNameToPlay = "-" then
        set castNameToPlay to "Hyphen"
      else
        if castNameToPlay = "." then
          set castNameToPlay to "Period"
        end if
      end if
    end if
  end if
  pPlayMySound(castNameToPlay)
